<?php
/**
 * 升级运行文件
 * @作者 qinggan <admin@phpok.com>
 * @主页 http://www.phpok.com
 * @授权 http://www.phpok.com/lgpl.html 开源授权协议：GNU Lesser General Public License
 * @时间 2021年12月28日
**/

/**
 * 安全限制，防止直接访问
**/
if(!defined("PHPOK_SET")){
	exit("<h1>Access Denied</h1>");
}

/**
 * 删除无用的 safecheck
 * 时间：2021年12月28日
**/
$folder = $this->dir_app."safecheck";
if(file_exists($folder)){
	$this->lib('file')->rm($this->dir_app."safecheck",true);
}
$sql = "SELECT * FROM ".$this->db->prefix."sysmenu WHERE appfile='safecheck'";
$rs = $this->db->get_one($sql);
if($rs){
	$sql = "DELETE FROM ".$this->db->prefix."popedom WHERE gid='".$rs['id']."'";
	$this->db->query($sql);
	$sql = "DELETE FROM ".$this->db->prefix."sysmenu WHERE id='".$rs['id']."'";
	$this->db->query($sql);
}

/**
 * 检查财富表字段
**/
$fields = $this->db->list_fields('wealth');
if(!in_array('banner',$fields)){
	$sql = "ALTER TABLE ".$this->db->prefix."wealth ADD banner varchar(255) NOT NULL COMMENT '大图'";
	$this->db->query($sql);
}
if(!in_array('thumb',$fields)){
	$sql = "ALTER TABLE ".$this->db->prefix."wealth ADD thumb varchar(255) NOT NULL COMMENT '小图'";
	$this->db->query($sql);
}
if(!in_array('iconfont',$fields)){
	$sql = "ALTER TABLE ".$this->db->prefix."wealth ADD iconfont varchar(255) NOT NULL COMMENT '字体图标'";
	$this->db->query($sql);
}

/**
 * 删除 user_autologin
 * 时间：2022年1月10日
**/
$tblist = $this->db->list_tables();
if(in_array($this->db->prefix."user_autologin",$tblist)){
	$sql = "DROP TABLE IF EXISTS ".$this->db->prefix."user_autologin";
	$this->db->query($sql);
}

/**
 * 删除 api_code 参数
 * 时间：2022年1月11日 
**/
$fields = $this->db->list_fields('site');
if(in_array('api_code',$fields)){
	$sql = "ALTER TABLE ".$this->db->prefix."site DROP api_code";
	$this->db->query($sql);
}

/**
 * 增加 admin_group 后台分组
 * 时间：2022年1月24日
**/
$fields = $this->db->list_fields('project');
if(!in_array('admin_group',$fields)){
	$sql = "ALTER TABLE `".$this->db->prefix."project` ADD `admin_group` VARCHAR( 255 ) NOT NULL COMMENT '后台分组'";
	$this->db->query($sql);
}

/**
 * 增加全文搜索
 * 时间：2022年2月13日
**/
$sql = "CREATE TABLE IF NOT EXISTS `".$this->db->prefix."fulltext` (`id` int(10) unsigned NOT NULL DEFAULT '0',`site_id` int(10) unsigned NOT NULL DEFAULT '0' COMMENT '站点ID',`project_id` int(10) unsigned NOT NULL DEFAULT '0' COMMENT '项目ID',`module_id` int(10) unsigned NOT NULL DEFAULT '0' COMMENT '模块ID',`cate_id` int(10) unsigned NOT NULL DEFAULT '0' COMMENT '分类ID',`dateline` int(10) unsigned NOT NULL DEFAULT '0' COMMENT '最后执行时间',`content` text NOT NULL COMMENT '全文索引',PRIMARY KEY (`id`),KEY `site_id` (`site_id`,`project_id`,`module_id`,`cate_id`),FULLTEXT KEY `content` (`content`)) ENGINE=MyISAM DEFAULT CHARSET=utf8 COMMENT='全文搜索，以此定位ID，独立模块不支持'";
$this->db->query($sql);


/**
 * 增加统计
 * 时间：2022年2月18日
**/
$sql = "CREATE TABLE IF NOT EXISTS `".$this->db->prefix."stat` (`id` int(10) unsigned NOT NULL AUTO_INCREMENT COMMENT '自增ID',`dateinfo` int(10) unsigned NOT NULL DEFAULT '0' COMMENT '日期',`pv` int(10) unsigned NOT NULL DEFAULT '0' COMMENT '页面浏览数',`uv` int(10) unsigned NOT NULL DEFAULT '0' COMMENT '用户数',`ip` int(10) unsigned NOT NULL DEFAULT '0' COMMENT 'IP数',PRIMARY KEY (`id`),UNIQUE KEY `dateinfo` (`dateinfo`)) ENGINE=MyISAM  DEFAULT CHARSET=utf8 COMMENT='统计' AUTO_INCREMENT=1";
$this->db->query($sql);

$sql = "CREATE TABLE IF NOT EXISTS `".$this->db->prefix."stat_info` (`id` int(10) unsigned NOT NULL AUTO_INCREMENT COMMENT '自增ID',`stat_id` int(10) unsigned NOT NULL DEFAULT '0' COMMENT '对应主表stat里的ID',`e_year` varchar(5) NOT NULL COMMENT '年',`e_month` varchar(5) NOT NULL COMMENT '月份',`e_day` varchar(5) NOT NULL COMMENT '日',`e_hour` varchar(5) NOT NULL COMMENT '时',`e_browser` varchar(50) NOT NULL COMMENT '浏览器',`e_version` varchar(10) NOT NULL COMMENT '版本号',`e_country` varchar(50) NOT NULL COMMENT '国家',`e_province` varchar(60) NOT NULL COMMENT '省份',`e_city` varchar(60) NOT NULL COMMENT '城市',`e_net` varchar(20) NOT NULL COMMENT '网络',`e_device` varchar(10) NOT NULL COMMENT '设备',`e_pixel` varchar(10) NOT NULL COMMENT '设备分辨率',`e_os` VARCHAR(20) NOT NULL COMMENT '操作系统',`pv` int(10) unsigned NOT NULL DEFAULT '0' COMMENT '访问页面数',`uv` int(10) unsigned NOT NULL DEFAULT '0' COMMENT '用户数',`ip` int(10) unsigned NOT NULL DEFAULT '0' COMMENT 'IP数',PRIMARY KEY (`id`),KEY `stat_id` (`stat_id`)) ENGINE=MyISAM  DEFAULT CHARSET=utf8 COMMENT='统计明细' AUTO_INCREMENT=1";
$this->db->query($sql);

/**
 * 用于手动检查
**/
$fields = $this->db->list_fields('stat_info');
if(!in_array('e_os',$fields)){
	$sql = "ALTER TABLE `".$this->db->prefix."stat_info` ADD `e_os` VARCHAR( 20 ) NOT NULL COMMENT '操作系统'";
	$this->db->query($sql);
}

/**
 * 升级独立模块对应的系统字段
**/
$modulelist = $this->model('module')->get_all();
if($modulelist){
	foreach($modulelist as $key=>$value){
		if(!$value['mtype']){
			continue;
		}
		$fields = $this->db->list_fields($value['id']);
		if(!in_array('status',$fields)){
			$data = array('id'=>'status','type'=>'TINYINT','unsigned'=>true,'notnull'=>true,'default'=>'0');
			$data['comment'] = '状态';
			$this->db->update_table_fields($tblname,$data);
		}
		if(!in_array('hidden',$fields)){
			$data = array('id'=>'hidden','type'=>'TINYINT','unsigned'=>true,'notnull'=>true,'default'=>'0');
			$data['comment'] = '隐藏';
			$this->db->update_table_fields($tblname,$data);
		}
		if(!in_array('sort',$fields)){
			$data = array('id'=>'sort','type'=>'INT','unsigned'=>true,'notnull'=>true,'default'=>'0');
			$data['comment'] = '排序';
			$this->db->update_table_fields($tblname,$data);
		}
		if(!in_array('dateline',$fields)){
			$data = array('id'=>'dateline','type'=>'INT','unsigned'=>true,'notnull'=>true,'default'=>'0');
			$data['comment'] = '发布时间';
			$this->db->update_table_fields($tblname,$data);
		}
		if(!in_array('hits',$fields)){
			$data = array('id'=>'hits','type'=>'INT','unsigned'=>true,'notnull'=>true,'default'=>'0');
			$data['comment'] = '查看次数';
			$this->db->update_table_fields($tblname,$data);
		}
	}
}

